import wnim, times, winim
import BinToBase64 # zum entpacken der Fontdaten
include "res.nim" # Ressource file mit den Mime-Daten

var
  fontdata = Base64ToBin(resFont) # resFont befindet sich in "res.nim"
  pFont: ptr = fontdata[0].addr # Pointer auf die Fontdaten
  iLen = fontdata.len # laenge der Fontdaten
  reserved: DWORD = 0 # reserviert (muss 0 sein)
  numFonts: DWORD = 1 # die Anzahl der Fonts innerhalb der Fontdaten
echo "pFont: ", pFont.repr # nur zum debuggen
echo "iLen: ", iLen # nur zum debuggen

# den Font im Speicher ("Double Feature") dem System bekannt machen
let hFont = AddFontMemResourceEx(pFont, DWORD(iLen), reserved.addr, numFonts.addr)
echo "hFont: ", hFont.repr # nur zum debuggen

# der Rest ist nur zur Demonstration, dass man den Font normal verwenden kann
let app = App()
let frame = Frame(title="Timer Test", size=(380, 200))
let panel = Panel(frame)
panel.setBackgroundColor(0x001A1A1A)

let timeLbl = StaticText(panel, label="Test giylpa öäüß", pos=(20, 10), size=(300, 50))
timeLbl.font = Font(18, faceName="Double Feature", weight=wFontWeightNormal)
timeLbl.setForegroundColor(0x00CCCCCC) # BGR-Format

let timeCtrl = StaticText(panel, label="00:00:00", pos=(20, 50), size=(320, 80), style=wAlignCenter)
timeCtrl.font = Font(40, faceName="Double Feature", weight=wFontWeightNormal)
timeCtrl.setForegroundColor(0x0000AA00) # BGR-Format

frame.startTimer(1.0) # starte den Timer (Zeit in Sekunden als Float)

frame.wEvent_Timer do (event: wEvent): # hier wird der Timer-Event ausgewertet
  let dt = now() # Datum/Uhrzeit holen
  timeCtrl.setLabel(dt.format("HH:mm:ss")) # und formatiert in das Text-Ctrl schreiben

frame.center()
frame.show()
app.mainLoop()
